﻿Public MustInherit Class INamingStrategy
    Protected model As ModelACoAR

    Public Sub setModel(ByVal m As ModelACoAR)
        model = m
    End Sub

    Public MustOverride Sub process()

End Class


Public Class NamingSimple
    Inherits INamingStrategy

    Public Overrides Sub process()
        Dim lst As New List(Of String)
        Dim ccIndex = 0
        For Each vcVector In model.VC

            If model.Z.getConcepts.Item(ccIndex).classifiedResources.Count > 0 Then
                Dim vector(0 To vcVector.values.Length - 1) As Integer
                vcVector.values.CopyTo(vector, 0)
                Array.Sort(vector)
                Array.Reverse(vector)
                Dim index1, index2 As Integer
                Dim max1, max2 As Integer
                max1 = vector(0)
                max2 = vector(1)

                index1 = 0
                While vcVector.getValue(index1) <> max1
                    index1 += 1
                End While

                index2 = 0
                While vcVector.getValue(index2) <> max2
                    index2 += 1
                End While

                If index2 = index1 Then
                    index2 += 1
                    While vcVector.getValue(index2) <> max2
                        index2 += 1
                    End While
                End If

                Dim dtag1 As String = model.D(index1).text
                Dim dtag2 As String = model.D(index2).text

                Dim ConceptName As String = dtag1 + "&" + dtag2

                model.Z.getConcepts().Item(ccIndex).setConceptName(ConceptName)
            End If
            ccIndex += 1
        Next


    End Sub
End Class