﻿Public MustInherit Class SimilarityMeasure

    Public MustOverride Function similarity(ByVal v1 As Integer(), ByVal v2 As Integer()) As Double

End Class

Public Class SimilarityMeasureCosine
    Inherits SimilarityMeasure

    Public Overrides Function similarity(ByVal v1() As Integer, ByVal v2() As Integer) As Double
        Dim v1_i As Integer
        Dim v2_i As Integer
        Dim num As Integer
        Dim den1 As Integer
        Dim den2 As Integer

        For i As Integer = 0 To v1.Length - 1
            v1_i = v1(i)
            v2_i = v2(i)
            num += v1_i * v2_i
            den1 += v1_i * v1_i
            den2 += v2_i * v2_i
        Next

        If den1 = 0 Or den2 = 0 Then
            Return 0
        Else
            Return num / (Math.Sqrt(den1) * Math.Sqrt(den2))
        End If
    End Function
End Class