﻿
Public Class vector

    Public values As Integer()
    Private firstInsertion As Boolean

    Public Sub New()
        redimVector(1)
        firstInsertion = True
    End Sub

    Public Sub redimVector(ByVal n As Integer)
        'n es el tamaño del vector
        ReDim Preserve values(0 To n - 1)
    End Sub

    Public Sub add(ByVal x As Integer)
        If firstInsertion Then
            values(0) = x
            firstInsertion = False
        Else
            redimVector(values.Length + 1)
            values(values.GetUpperBound(0)) = x
        End If

    End Sub

    Public Sub drop(ByVal n As Integer)
        If n < values.Length Then
            For x As Integer = n To values.GetUpperBound(0) - 1
                values(x) = values(x + 1)
            Next
            redimVector(values.Length - 1)
        End If
    End Sub

    Public Function getValue(ByVal i As Integer) As Integer
        Return values(i)
    End Function

    Public Sub setValue(ByVal v As Integer, ByVal index As Integer)
        values(index) = v
    End Sub

    Public Function length() As Integer
        Return values.Length
    End Function

    Public Overrides Function ToString() As String
        Dim cadena As String = ""

        For Each e As Integer In values
            cadena &= e.ToString + "  "
        Next

        Return cadena
    End Function

    Public Shared Sub vector_sum(ByVal v1 As vector, ByVal v2 As vector)
        'Se le suma al vector v1 el vector v2
        For k As Integer = 0 To v1.values.GetUpperBound(0)
            v1.values(k) += v2.values(k)
        Next

    End Sub

    Public Function searchFor(ByVal value As Integer) As Integer
        'Devuelve la primera posición en la que aparece un valor en el vector
        Dim i As Integer = 0
        While values(i) <> value
            i += 1
        End While

        Return i
    End Function

    Public Sub sortDescending()
        Array.Sort(values)
        Array.Reverse(values)
    End Sub


End Class