﻿Public Class ImagenEtiquetada
    Private IdImagen As Integer
    Private etiquetas As List(Of Etiqueta)
    Public arbolObservador As arbol

    Public Sub New(ByVal i As Integer)
        IdImagen = i
        etiquetas = New List(Of Etiqueta)
    End Sub

    Public Sub set_observador(ByVal a As arbol)
        arbolObservador = a
    End Sub

    Public Function get_IdImagen() As Integer
        Return IdImagen
    End Function

    Public Function get_etiquetas() As List(Of Etiqueta)
        Return etiquetas
    End Function

    Public Sub añadir_etiqueta(ByVal padre As Integer, ByVal Left As Double, ByVal Top As Double, ByVal Width As Double, ByVal Height As Double, ByVal c As Canvas, ByVal colorRec As SolidColorBrush, ByVal id As Integer)
        Dim eti As New Etiqueta(padre, Left, Top, Width, Height, colorRec, id)
        eti.set_observador(c)
        etiquetas.Add(eti)
    End Sub

    Public Function buscar_etiqueta(ByVal idEtiqueta As Integer) As Etiqueta
        Dim index As Integer
        index = 0

        While etiquetas(index).get_id() <> idEtiqueta And index < etiquetas.Count
            index = index + 1
        End While

        Return etiquetas(index)
    End Function

    Public Sub eliminar_etiqueta(ByVal eti As Etiqueta)
        eti.borrar_etiqueta()
        etiquetas.Remove(eti)
    End Sub

    Public Sub eliminar_TodasLasEtiquetas()

        For index As Integer = 0 To etiquetas.Count - 1

            Dim eti = etiquetas.ElementAt(index)
            eti.borrar_etiqueta()
            etiquetas.Remove(eti)

        Next

    End Sub

    Public Function buscar_etiqueta_zoom(ByVal isEtiqueta As String, ByVal listaZoom As List(Of VisualizarConZoom)) As VisualizarConZoom
        Dim index As Integer
        index = 0

        While listaZoom(index).get_id <> isEtiqueta And index < etiquetas.Count
            index = index + 1
        End While

        Return listaZoom(index)
    End Function

    Public Sub eliminar_etiqueta_zoom(ByVal etiZoom As VisualizarConZoom, ByVal listaZoom As List(Of VisualizarConZoom))
        etiZoom.borrar_etiqueta()
        listaZoom.Remove(etiZoom)
    End Sub

    Public Sub visualizar_todas_etiquetas(ByVal c As Canvas)
        no_visualizar_etiquetas(c) ' esto se hace para que se vuelvan a pintar todas, si no no funciona
        For Each Etiqueta In etiquetas
            Etiqueta.pintar_etiqueta()
        Next
    End Sub

    Public Sub no_visualizar_etiquetas(ByVal c As Canvas)
        For Each Etiqueta In etiquetas
            Etiqueta.borrar_etiqueta()
        Next
    End Sub

    Public Sub borrar_rellenos()
        For Each Etiqueta In etiquetas
            Etiqueta.borrar_relleno()
        Next
    End Sub

End Class
