﻿
Option Compare Binary
Option Infer On
Option Strict On
Option Explicit On

Imports IMaGeProject.Web
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Data.Objects.DataClasses
Imports System.Linq
Imports System.ServiceModel.DomainServices.Hosting
Imports System.ServiceModel.DomainServices.Server


'The MetadataTypeAttribute identifies EtiquetasImagenMetadata as the class
' that carries additional metadata for the EtiquetasImagen class.
<MetadataTypeAttribute(GetType(EtiquetasImagen.EtiquetasImagenMetadata))>  _
Partial Public Class EtiquetasImagen
    
    'This class allows you to attach custom attributes to properties
    ' of the EtiquetasImagen class.
    '
    'For example, the following marks the Xyz property as a
    ' required property and specifies the format for valid values:
    '    <Required()>
    '    <RegularExpression("[A-Z][A-Za-z0-9]*")>
    '    <StringLength(32)>
    '    Public Property Xyz As String
    Friend NotInheritable Class EtiquetasImagenMetadata
        
        'Metadata classes are not meant to be instantiated.
        Private Sub New()
            MyBase.New
        End Sub
        
        Public Property Color As String
        
        Public Property Height As Integer
        
        Public Property Id As Integer
        
        Public Property IdEtiqueta As Integer
        
        Public Property IdImagen As Integer
        
        Public Property Imagenes As Imagenes
        
        Public Property ListadoEtiquetas As ListadoEtiquetas
        
        Public Property Padre As Nullable(Of Integer)
        
        Public Property Votos As Nullable(Of Integer)
        
        Public Property Width As Integer
        
        Public Property X As Integer
        
        Public Property Y As Integer
    End Class
End Class

'The MetadataTypeAttribute identifies ImagenesMetadata as the class
' that carries additional metadata for the Imagenes class.
<MetadataTypeAttribute(GetType(Imagenes.ImagenesMetadata))>  _
Partial Public Class Imagenes
    
    'This class allows you to attach custom attributes to properties
    ' of the Imagenes class.
    '
    'For example, the following marks the Xyz property as a
    ' required property and specifies the format for valid values:
    '    <Required()>
    '    <RegularExpression("[A-Z][A-Za-z0-9]*")>
    '    <StringLength(32)>
    '    Public Property Xyz As String
    Friend NotInheritable Class ImagenesMetadata
        
        'Metadata classes are not meant to be instantiated.
        Private Sub New()
            MyBase.New
        End Sub
        
        Public Property EtiquetasImagen As EntityCollection(Of EtiquetasImagen)
        
        Public Property id As Integer
        
        Public Property Nombre As String
        
        Public Property Ruta As String
    End Class
End Class

'The MetadataTypeAttribute identifies ListadoEtiquetasMetadata as the class
' that carries additional metadata for the ListadoEtiquetas class.
<MetadataTypeAttribute(GetType(ListadoEtiquetas.ListadoEtiquetasMetadata))>  _
Partial Public Class ListadoEtiquetas
    
    'This class allows you to attach custom attributes to properties
    ' of the ListadoEtiquetas class.
    '
    'For example, the following marks the Xyz property as a
    ' required property and specifies the format for valid values:
    '    <Required()>
    '    <RegularExpression("[A-Z][A-Za-z0-9]*")>
    '    <StringLength(32)>
    '    Public Property Xyz As String
    Friend NotInheritable Class ListadoEtiquetasMetadata
        
        'Metadata classes are not meant to be instantiated.
        Private Sub New()
            MyBase.New
        End Sub
        
        Public Property EtiquetasImagen As EntityCollection(Of EtiquetasImagen)
        
        Public Property Id As Integer
        
        Public Property Nombre As String
        
        Public Property Padre As Nullable(Of Integer)
    End Class
End Class

