﻿
Option Compare Binary
Option Infer On
Option Strict On
Option Explicit On

Imports IMaGeProject.Web
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Data
Imports System.Linq
Imports System.ServiceModel.DomainServices.EntityFramework
Imports System.ServiceModel.DomainServices.Hosting
Imports System.ServiceModel.DomainServices.Server


'Implements application logic using the IMaGeDatabaseEntities12 context.
' TODO: Add your application logic to these methods or in additional methods.
' TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
' Also consider adding roles to restrict access as appropriate.
'<RequiresAuthentication> _
<EnableClientAccess()>  _
Public Class IMaGeDomainService
    Inherits LinqToEntitiesDomainService(Of IMaGeDatabaseEntities12)
    
    'TODO:
    ' Consider constraining the results of your query method.  If you need additional input you can
    ' add parameters to this method or create additional query methods with different names.
    'To support paging you will need to add ordering to the 'EtiquetasImagen' query.
    Public Function GetEtiquetasImagen() As IQueryable(Of EtiquetasImagen)
        Return Me.ObjectContext.EtiquetasImagen
    End Function
    
    Public Sub InsertEtiquetasImagen(ByVal etiquetasImagen As EtiquetasImagen)
        If ((etiquetasImagen.EntityState = EntityState.Detached)  _
                    = false) Then
            Me.ObjectContext.ObjectStateManager.ChangeObjectState(etiquetasImagen, EntityState.Added)
        Else
            Me.ObjectContext.EtiquetasImagen.AddObject(etiquetasImagen)
        End If
    End Sub
    
    Public Sub UpdateEtiquetasImagen(ByVal currentEtiquetasImagen As EtiquetasImagen)
        Me.ObjectContext.EtiquetasImagen.AttachAsModified(currentEtiquetasImagen, Me.ChangeSet.GetOriginal(currentEtiquetasImagen))
    End Sub
    
    Public Sub DeleteEtiquetasImagen(ByVal etiquetasImagen As EtiquetasImagen)
        If (etiquetasImagen.EntityState = EntityState.Detached) Then
            Me.ObjectContext.EtiquetasImagen.Attach(etiquetasImagen)
        End If
        Me.ObjectContext.EtiquetasImagen.DeleteObject(etiquetasImagen)
    End Sub
    
    'TODO:
    ' Consider constraining the results of your query method.  If you need additional input you can
    ' add parameters to this method or create additional query methods with different names.
    'To support paging you will need to add ordering to the 'Imagenes' query.
    Public Function GetImagenes() As IQueryable(Of Imagenes)
        Return Me.ObjectContext.Imagenes
    End Function
    
    Public Sub InsertImagenes(ByVal imagenes As Imagenes)
        If ((imagenes.EntityState = EntityState.Detached)  _
                    = false) Then
            Me.ObjectContext.ObjectStateManager.ChangeObjectState(imagenes, EntityState.Added)
        Else
            Me.ObjectContext.Imagenes.AddObject(imagenes)
        End If
    End Sub
    
    Public Sub UpdateImagenes(ByVal currentImagenes As Imagenes)
        Me.ObjectContext.Imagenes.AttachAsModified(currentImagenes, Me.ChangeSet.GetOriginal(currentImagenes))
    End Sub
    
    Public Sub DeleteImagenes(ByVal imagenes As Imagenes)
        If (imagenes.EntityState = EntityState.Detached) Then
            Me.ObjectContext.Imagenes.Attach(imagenes)
        End If
        Me.ObjectContext.Imagenes.DeleteObject(imagenes)
    End Sub
    
    'TODO:
    ' Consider constraining the results of your query method.  If you need additional input you can
    ' add parameters to this method or create additional query methods with different names.
    'To support paging you will need to add ordering to the 'ListadoEtiquetas' query.
    Public Function GetListadoEtiquetas() As IQueryable(Of ListadoEtiquetas)
        Return Me.ObjectContext.ListadoEtiquetas
    End Function
    
    Public Sub InsertListadoEtiquetas(ByVal listadoEtiquetas As ListadoEtiquetas)
        If ((listadoEtiquetas.EntityState = EntityState.Detached)  _
                    = false) Then
            Me.ObjectContext.ObjectStateManager.ChangeObjectState(listadoEtiquetas, EntityState.Added)
        Else
            Me.ObjectContext.ListadoEtiquetas.AddObject(listadoEtiquetas)
        End If
    End Sub
    
    Public Sub UpdateListadoEtiquetas(ByVal currentListadoEtiquetas As ListadoEtiquetas)
        Me.ObjectContext.ListadoEtiquetas.AttachAsModified(currentListadoEtiquetas, Me.ChangeSet.GetOriginal(currentListadoEtiquetas))
    End Sub
    
    Public Sub DeleteListadoEtiquetas(ByVal listadoEtiquetas As ListadoEtiquetas)
        If (listadoEtiquetas.EntityState = EntityState.Detached) Then
            Me.ObjectContext.ListadoEtiquetas.Attach(listadoEtiquetas)
        End If
        Me.ObjectContext.ListadoEtiquetas.DeleteObject(listadoEtiquetas)
    End Sub
End Class

