﻿Partial Public Class MyAutoCompleteBox
    Inherits UserControl

    Private marcaAgua As Boolean
    Private pincelMarcaAgua As SolidColorBrush
    Private pincelNegro As SolidColorBrush
    Private defaultText As String

    Private _text As String
    Public Property text() As String
        Get
            Return _text
        End Get
        Set(ByVal value As String)
            _text = value
        End Set
    End Property


    Public Sub New 
        InitializeComponent()
        marcaAgua = True
        pincelMarcaAgua = New SolidColorBrush(Color.FromArgb(&HFF, &H6C, &H86, &H68))
        pincelNegro = New SolidColorBrush(Colors.Black)
        defaultText = "Nombre de la nueva etiqueta"
        ponerMarcaAgua()
    End Sub

    Public Sub setDefaultText(ByVal s As String)
        defaultText = s
    End Sub

    Public Sub ponerMarcaAgua()
        Me.AutoCompleteBox1.Foreground = pincelMarcaAgua
        Me.AutoCompleteBox1.FontStyle = FontStyles.Italic
        Me.AutoCompleteBox1.Text = defaultText
    End Sub

    Public Sub quitarMarcaAgua()
        Me.AutoCompleteBox1.Foreground = pincelNegro
        Me.AutoCompleteBox1.FontStyle = FontStyles.Normal
        Me.AutoCompleteBox1.Text = ""
    End Sub

End Class
