﻿Imports IMaGeProject.Web

Partial Public Class galeria
    Inherits UserControl

    Private MiMediador As Mediador
    Private idImagen As Integer
    Private CambiaConBoton As Boolean = False

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Sub conocerMediador(ByVal m As Mediador)
        MiMediador = m
    End Sub

    Private Sub ListBox1_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox_Galeria.SelectionChanged

        'Quitamos los checks por si están activados
        MiMediador.quitarCheck()

        'Guardar el Id de la imagen
        idImagen = ListBox_Galeria.SelectedItem.Id

        MiMediador.nuevaImagen(Me.ListBox_Galeria.SelectedItem.Ruta)
        'Miramos si el zoom está activado
        If MiMediador.EstaZoomActivado Then
            MiMediador.mostrarImagenOriginal()
        End If
        'Cambiamos los botones en la barra de herramientas
        MiMediador.CambioDeImagenEnBarra()
        MiMediador.limpiarVisor()
        'Cargamos las etiquetas de la imagen
        MiMediador.CargarArbol(idImagen)
    End Sub

    Private Sub Button_Anterior_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Anterior.Click
        If ListBox_Galeria.SelectedIndex = -1 Then
            ListBox_Galeria.SelectedIndex = 0

            ''Guardar el Id de la imagen
            'idImagen = ListBox_Galeria.SelectedItem.Id



        ElseIf (ListBox_Galeria.SelectedIndex <> 0) Then
            ListBox_Galeria.SelectedIndex = ListBox_Galeria.SelectedIndex - 1

            ''Guardar el Id de la imagen
            'idImagen = ListBox_Galeria.SelectedItem.Id

            'MiMediador.nuevaImagen(Me.ListBox_Galeria.SelectedItem.Ruta)

            ''Miramos si el zoom está activado
            'If MiMediador.EstaZoomActivado Then
            '    MiMediador.mostrarImagenOriginal()
            'End If
            'Cambiamos los botones en la barra de herramientas
            'MiMediador.CambioDeImagenEnBarra()
            'MiMediador.limpiarVisor()

        End If
    End Sub

    Private Sub Button_Siguiente_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button_Siguiente.Click
        Dim total As Integer
        total = ListBox_Galeria.Items.Count
        If ListBox_Galeria.SelectedIndex = -1 Then
            ListBox_Galeria.SelectedIndex = 0

            ''Guardar el Id de la imagen
            'idImagen = ListBox_Galeria.SelectedItem.Id


            ''Miramos si el zoom está activado
            'If MiMediador.EstaZoomActivado Then
            '    MiMediador.mostrarImagenOriginal()
            'End If
            'Cambiamos los botones en la barra de herramientas
            'MiMediador.CambioDeImagenEnBarra()
            'MiMediador.nuevaImagen(Me.ListBox_Galeria.SelectedItem.Ruta)
            'MiMediador.limpiarVisor()


        ElseIf (ListBox_Galeria.SelectedIndex <> total - 1) Then
            ListBox_Galeria.SelectedIndex = ListBox_Galeria.SelectedIndex + 1

            ''Guarde el Id de la imagen
            'idImagen = ListBox_Galeria.SelectedItem.Id

            ''Miramos si el zoom está activado
            'If MiMediador.EstaZoomActivado Then
            '    MiMediador.mostrarImagenOriginal()
            'End If
            'Cambiamos los botones en la barra de herramientas
            'MiMediador.CambioDeImagenEnBarra()
            'MiMediador.nuevaImagen(Me.ListBox_Galeria.SelectedItem.Ruta)
            'MiMediador.limpiarVisor()

        End If

    End Sub


    Public Function getIdImagen() As Integer
        Return idImagen
    End Function

    Private Sub ImagenesDomainDataSource_LoadedData(ByVal sender As System.Object, ByVal e As System.Windows.Controls.LoadedDataEventArgs) Handles ImagenesDomainDataSource.LoadedData

        If e.HasError Then
            System.Windows.MessageBox.Show(e.Error.ToString, "Load Error", System.Windows.MessageBoxButton.OK)
            e.MarkErrorAsHandled()
        End If

    End Sub
End Class
